datablock ItemData(carKeyItem : redKeyItem)
{
	shapeFile = "./carKey.dts";
	uiName = "Key Car";
	iconName = "./carKeyIcon";
	colorShiftColor = "0.7 0.7 0.7 1";
	image = carKeyImage;
};

datablock ShapeBaseImageData(carKeyImage : redKeyImage)
{
   shapeFile = "./carKey.dts";
   colorShiftColor = carKeyItem.colorShiftColor;
};

function carKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}

function carKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}


function carKeyImage::onFire(%this, %player, %slot)
{
   %start = %player.getEyePoint();
   %vec = vectorScale(%player.getMuzzleVector(%slot), 10  * getWord(%player.getScale(), 2) );
   %end = vectorAdd(%start, %vec);
   %mask = $TypeMasks::VehicleObjectType;

   %rayCast = containerRayCast(%start, %end, %mask);

   if(!%rayCast)
      return;

   %hitObj = getWord(%rayCast, 0);
   %hitPos = getWords(%rayCast, 1, 3);
   %hitNormal = getWords(%rayCast, 4, 6);

   %this.onHitObject(%player, %slot, %hitObj, %hitPos, %hitNormal);   
}

function carKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	if(%hitObj.getType() & $TypeMasks::VehicleObjectType)
	{
		if(getBrickGroupFromObject(%player) == getBrickGroupFromObject(%hitObj) || (%player.client.isAdmin && $Pref::Server::VehicleLock::AdminLockAnyCar))
		{
			if(%hitObj.isLocked)
			{
				%hitObj.isLocked = 0;
				messageClient(%player.client, '', "\c6Vehicle unlocked");
			}
			else
			{
				%hitObj.isLocked = 1;
				messageClient(%player.client, '', "\c6Vehicle locked");
			}
		}
		else
		{
			%player.client.centerPrint("You cannot lock or unlock this vehicle.", 3);
		}
	}
}