if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

	RTB_registerPref("Admins Can Always Enter", "Vehicle Lock", "$Pref::Server::VehicleLock::AdminsCanEnter", "bool", "Script_VehicleLock", true, false, true, "VehicleLock_AdminsCanEnter");
	RTB_registerPref("Admins Can Lock Any Vehicle", "Vehicle Lock", "$Pref::Server::VehicleLock::AdminLockAnyCar", "bool", "Script_VehicleLock", true, false, true, "VehicleLock_AdminLockAnyCar");
}
else
{
	$Pref::Server::VehicleLock::AdminsCanEnter = 1;
	$Pref::Server::VehicleLock::AdminLockAnyCar = 1;
}

if($Pref::Server::VehicleLock::AdminsCanEnter $= "")
{
	$Pref::Server::VehicleLock::AdminsCanEnter = 1;
}

if($Pref::Server::VehicleLock::AdminLockAnyCar $= "")
{
	$Pref::Server::VehicleLock::AdminLockAnyCar = 1;
}

function serverCmdLockVehicle(%c)
{
	if(isObject(%c.player))
		%vehicle = %c.player.getObjectMount();

	if(!isObject(%vehicle))
		return;
		
	if(%vehicle.getType() & $TypeMasks::VehicleObjectType)
	{
		if(%vehicle.brickgroup == %c.brickgroup || (%c.isAdmin && $Pref::Server::VehicleLock::AdminLockAnyCar))
		{
			%vehicle.isLocked = 1;
			messageClient(%c, '', "\c6Vehicle locked");
		}
		else
		{
			%c.centerPrint("You cannot lock this vehicle.", 3);
		}
	}
}

function serverCmdUnlockVehicle(%c)
{
	if(isObject(%c.player))
		%vehicle = %c.player.getObjectMount();

	if(!isObject(%vehicle))
		return;
		
	if(%vehicle.getType() & $TypeMasks::VehicleObjectType)
	{
		if(%vehicle.brickgroup == %c.brickgroup || (%c.isAdmin && $Pref::Server::VehicleLock::AdminLockAnyCar))
		{
			%vehicle.isLocked = 0;
			messageClient(%c, '', "\c6Vehicle unlocked");
		}
		else
		{
			%c.centerPrint("You cannot unlock this vehicle.", 3);
		}
	}
}

function serverCmdLockVehicles(%c, %t)
{
	%count = missionCleanup.getCount();
	
	for(%i = %count - 1; %i > 0; %i--)
	{
		%obj = missionCleanup.getObject(%i);
		
		if(%obj.getType() & $TypeMasks::VehicleObjectType)
		{
			if(!%c.isAdmin || (%c.isAdmin && %t $= ""))
			{
				if(%obj.brickgroup == %c.brickgroup)
				{
					%obj.isLocked = 1;
					messageClient(%c, '', "\c6Vehicles locked");
				}
			}
			else if(%c.isAdmin && %t !$= "")
			{
				%t = findClientByName(%t);
				
				if(%obj.brickgroup == %t.brickgroup)
				{
					%obj.isLocked = 1;
					
					messageAll('MsgClearBricks', "\c3" @ %c.name SPC "\c2locked \c3" @ %t.name @ "\c2's vehicles");
					echo(%c.name SPC "locked " @ %t.name @ "'s vehicles");
				}
			}
		}
	}
}

function serverCmdUnlockVehicles(%c, %t)
{
	%count = missionCleanup.getCount();
	
	for(%i = %count - 1; %i > 0; %i--)
	{
		%obj = missionCleanup.getObject(%i);
		
		if(%obj.getType() & $TypeMasks::VehicleObjectType)
		{
			if(!%c.isAdmin || (%c.isAdmin && %t $= ""))
			{
				if(%obj.brickgroup == %c.brickgroup)
				{
					%obj.isLocked = 0;
					messageClient(%c, '', "\c6Vehicles unlocked");
				}
			}
			else if(%c.isAdmin && %t !$= "")
			{
				%t = findClientByName(%t);
				
				if(%obj.brickgroup == %t.brickgroup)
				{
					%obj.isLocked = 0;
					
					messageAll('MsgClearBricks', "\c3" @ %c.name SPC "\c2unlocked \c3" @ %t.name @ "\c2's vehicles");
					echo(%c.name SPC "unlocked " @ %t.name @ "'s vehicles");
				}
			}
		}
	}
}

function serverCmdLockAllVehicles(%c)
{
	if(!%c.isAdmin)
		return;
		
	%count = missionCleanup.getCount();
	
	for(%i = %count - 1; %i > 0; %i--)
	{
		%obj = missionCleanup.getObject(%i);
		
		if(%obj.getType() & $TypeMasks::VehicleObjectType)
		{
			%obj.isLocked = 1;
		}
	}
	messageAll('MsgClearBricks', "\c3" @ %c.name SPC "\c0locked all vehicles.");
}

function serverCmdUnlockAllVehicles(%c)
{
	if(!%c.isAdmin)
		return;
		
	%count = missionCleanup.getCount();
	
	for(%i = %count - 1; %i > 0; %i--)
	{
		%obj = missionCleanup.getObject(%i);
		
		if(%obj.getType() & $TypeMasks::VehicleObjectType)
		{
			%obj.isLocked = 0;
		}
	}
	messageAll('MsgClearBricks', "\c3" @ %c.name SPC "\c0unlocked all vehicles.");
}

package vehicleLockPackage
{
	function WheeledVehicleData::onCollision(%this, %obj, %col, %vec, %vecLen)
	{
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			if(!%col.client.isAdmin && getBrickGroupFromObject(%obj) != getBrickGroupFromObject(%col) && %obj.isLocked)
			{
				%col.client.centerPrint("This vehicle is locked.", 2);
				return;
			}

			if(%col.client.isAdmin && !$Pref::Server::VehicleLock::AdminsCanEnter && %obj.isLocked)
			{
				%col.client.centerPrint("This vehicle is locked.", 2);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %vec, %vecLen);
	}
	
	function FlyingVehicleData::onCollision(%this, %obj, %col, %vec, %vecLen)
	{
		if(%col.getType() & $TypeMasks::PlayerObjectType)
		{
			if(!%col.client.isAdmin && getBrickGroupFromObject(%obj) != getBrickGroupFromObject(%col) && %obj.isLocked)
			{
				%col.client.centerPrint("This vehicle is locked.", 2);
				return;
			}

			if(%col.client.isAdmin && !$Pref::Server::VehicleLock::AdminsCanEnter && %obj.isLocked)
			{
				%col.client.centerPrint("This vehicle is locked.", 2);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %vec, %vecLen);
	}
};
activatePackage(vehicleLockPackage);